package kd.hrmp.hbjm.business.cascadedata;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.utils.ObjectUtils;
import kd.hr.hbp.common.util.HRStringUtils;

/**
 * @author rd_ningjie
 * @description: 级联数据对比工具类
 * @date 2022/6/8 14:19
 */
public class CascadeDataValideUtil {


    /**
     * @param parent
     * @param sub
     * @param col
     * @description: 查看sub下挂载的col字段id值是否与parent主键值相同，调用者自己保证字段引用关系的正确，工具类不做多余的判断
     * @return: void
     * @author rd_ningjie
     * @date: 2022/6/8 14:22
     */
    public static boolean valideCascadeDynamicObject(DynamicObject parent, DynamicObject sub, String col) {

        if (ObjectUtils.isEmpty(parent) || ObjectUtils.isEmpty(col)) {
            return false;
        }
        if (ObjectUtils.isEmpty(sub)) {
            return true;
        }
        DynamicObject subParent = sub.getDynamicObject(col);
        if (!ObjectUtils.isEmpty(subParent) && HRStringUtils.equals(String.valueOf(parent.getPkValue()), String.valueOf(subParent.getPkValue()))) {
            return true;
        }
        return false;
    }
}
