package kd.hrmp.hbjm.business.domain.application.job;

import kd.bos.dataentity.entity.DynamicObject;
import kd.hrmp.hbjm.business.model.JobChangeInfoModel;
import kd.hrmp.hbjm.business.utils.model.JobDisableModel;

import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author rd_ningjie
 * @description: 职位相关聚合服务
 * @date 2022/6/16 10:34
 */
public interface IJobApplication {


    /**
     * @param sourceData
     * @param viewData
     * @description: 处理职位导入职级职等信息被置空的逻辑
     * @return: DynamicObject
     * @author rd_ningjie
     * @date: 2022/6/16 10:49
     */
    DynamicObject dealGradeOrLevelImportToNull(Map<String, Object> sourceData, DynamicObject viewData);

    /**
     * @param sourceData
     * @param viewData
     * @description: 处理职位导入变动原因置空的逻辑
     * @return: DynamicObject
     * @author rd_ningjie
     * @date: 2022/6/16 10:49
     */
    DynamicObject dealChangeReasonImportToNull(Map<String, Object> sourceData, DynamicObject viewData);

    /**
     * @param boids
     * @description: 根据boid查询所有的历史数据以及对应的变动原因变动类型等事务数据
     * @return: Map<Long, List < JobChangeInfoModel>>
     * @author rd_ningjie
     * @date: 2022/6/16 10:49
     */
    Map<Long, List<JobChangeInfoModel>> getAllChangeInfoByBoids(Set<Long> boids);

    /**
     * @param jobs
     * @description: 禁用职位
     * @return: DynamicObject[]
     * @author rd_ningjie
     * @date: 2022/6/17 17:03
     */
    DynamicObject[] disableJob(DynamicObject[] jobs, JobDisableModel models);

    /**
     * @param jobs
     * @description: 启用职位
     * @return: DynamicObject[]
     * @author rd_ningjie
     * @date: 2022/6/17 17:03
     */
    DynamicObject[] enableJob(DynamicObject[] jobs);

}
